# -*- coding: utf-8 -*-
"""
Created on Tue May 31 10:33:43 2022

@author: Jinhai
"""

import numpy as np
from DigiNet.layers import LSTM_hdw as LSTM

Paras_dic = {
    16:{
        4: [0x0200, 0x0000, 0x0100, 2],
        }
    }

class sigmoid_hdw(LSTM):
    
    def __init__(self, inputs):
        
        Quant = LSTM.Quantization
        
        paras = Paras_dic.get(Quant[0]).get(Quant[1])
        
        self.val = self.call(inputs, paras)
        
        
    def call(self, num, paras):
        
        [base, low, high, shift] = paras
        
        out = num.copy()
        dim = np.size(num)
        
        for i in range (dim):
            out[i] = np.piecewise(num[i], 
                                  
                                  [num[i] < -base, num[i] > base, 
                                   -base <= num[i] <= base],
                                  
                                  [low, high, ((num[i] + base) >> shift)])
            
        return tuple([hex(m) for m in out])