# -*- coding: utf-8 -*-
"""
Created on Tue May 31 10:32:57 2022

@author: Jinhai
"""

import numpy as np
from DigiNet.layers import LSTM_hdw as LSTM

Paras_dic = {
    16:{
        4: [0x009F, 0x01BA, -0x0100, 0x0058, 0x0068, 0x0100, 8]
        }
    }

class tanh_hdw(LSTM):
    
    def __init__(self, inputs):
        
        Quant = LSTM.Quantization
        paras = Paras_dic.get(Quant[0]).get(Quant[1])
        
        self.val = self.call(inputs, paras)
        
        
    def call(self, num, paras):
        
        [margin_l, margin_h, low, slope, bias, high, shift] = paras
        
        out = num.copy()
        dim = np.size(num)
        
        for i in range (dim):
            out[i] = np.piecewise(num[i], 
                                  
                                  [num[i] <= -margin_h, 
                                   -margin_h < num[i] <= -margin_l,
                                   -margin_l < num[i] < margin_l,
                                   margin_l <= num[i] < margin_h,
                                   num[i] >= margin_h],
                                  
                                  [low, 
                                   (slope * num[i] >> shift) - bias, 
                                   num[i], 
                                   (slope * num[i] >> shift) + bias, 
                                   high])
            
        return tuple([hex(n) for n in out])

