# -*- coding: utf-8 -*-
"""
Created on Tue May 31 10:26:35 2022

@author: Jinhai
"""

import numpy as np
import sys

class LSTM_sfw:
    
    def __init__(self, W_in, W_rec, Bias, input_len, output_len, shift_power):
        self.input_len  = input_len
        self.output_len = output_len
        self.shift_power = shift_power
        
        W_in_str  = np.loadtxt(W_in, dtype='str')
        W_rec_str = np.loadtxt(W_rec, dtype='str')
        Bias_str  = np.loadtxt(Bias, dtype='str')
        W_in  = np.zeros(np.shape(W_in_str))
        W_rec = np.zeros(np.shape(W_rec_str))
        Bias = np.zeros(np.shape(Bias_str))
        if np.shape(W_in_str)[0] == np.shape(W_rec_str)[0] == np.shape(Bias_str)[0]:
            dim = np.shape(W_in_str)[0]
            for i in range (dim):
                W_in[i] = [int(m, 16) for m in W_in_str[i]]
                W_rec[i] = [int(m, 16) for m in W_rec_str[i]]
                Bias[i] = [int(m, 16) for m in Bias_str[i]]
        else:
            print('Weight dimension do not match')
            sys.exit()
        
        self.W_in = W_in * 16 ** self.shift_power
        self.W_rec = W_rec * 16 ** self.shift_power
        self.Bias = Bias * 16 ** self.shift_power
        
        
        [self.W_f, self.W_g, self.W_i, self.W_o] = np.array([self.W_in]).reshape(4, self.output_len, self.input_len)
        [self.R_f, self.R_g, self.R_i, self.R_o] = np.array([self.W_rec]).reshape(4, self.output_len, self.output_len)
        [self.B_f, self.B_g, self.B_i, self.B_o] = np.array([self.Bias]).reshape(4, self.output_len)